#include <VBCoreG4_arduino_system.h>


#define IN1 PA8
#define IN2 PA9
#define SLEEPn PB3
#define USR_BTN PC13
#define VrefPin PA4

int forward = HIGH;
int prev_btnSt;
int buttonState;
int is_stopped = LOW;

void setup() {
 
  pinMode(PB3, OUTPUT);
  pinMode(IN1, OUTPUT);
  pinMode(IN2, OUTPUT);
  pinMode(VrefPin, OUTPUT);
  pinMode(USR_BTN, INPUT_PULLUP);
 
  digitalWrite(VrefPin, HIGH);
  digitalWrite(SLEEPn, HIGH);
  digitalWrite(IN1, LOW);
  digitalWrite(IN2, LOW);

  prev_btnSt = digitalRead(USR_BTN);

  Serial.begin(500000);
  delay(1000);
}

void loop() {

  buttonState = digitalRead(USR_BTN);
  if(buttonState == LOW && prev_btnSt == HIGH){
    forward = !forward;
    prev_btnSt = buttonState;
  }
  if(buttonState == HIGH) {prev_btnSt = buttonState;}
  
  if (forward == HIGH && is_stopped == LOW){
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2, LOW);
  }

  else if (forward == LOW && is_stopped == LOW){
  digitalWrite(IN1, LOW);
  digitalWrite(IN2, HIGH);
  }

  else{
      digitalWrite(IN1, LOW);
      analogWrite(IN2, 200);
  }
  
  if (Serial.available() > 0) {
    is_stopped = Serial.readString().toInt();
    
  }
}

